
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "cell.h"
#include "rif.h"
#include "sif.h"

extern double	Convert(/* double value */);

static void	ConvertValue(pathI,baseI,stepI,pathO,baseO,stepO,BPS)
char		*pathI,*pathO;
double		baseI,stepI,baseO,stepO;
int		BPS;
{
	int	Nx,Ny,x,y;
	Cell	**cell,cell0=(Cell)((1<<BPS)-1);
	double	value,value0=baseO+stepO*(double)cell0;

	ReadImageFile(pathI,&Nx,&Ny,NULL,&cell,NULL);

	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++) {
	    value=Convert(baseI+stepI*(double)cell[y][x]);

	    if (value<baseO)
		cell[y][x]=0;
	    else if (value>value0)
		cell[y][x]=cell0;
	    else
		cell[y][x]=(Cell)floor((value-baseO)/stepO+0.5);
	}
	StoreImageFile(pathO,Nx,Ny,BPS,cell,NULL);

	for (y=Ny-1; y>=0; y--) free(cell[y]); free(cell);
}

#define PATH_LEN	256

int	main(argc,argv)
int	argc;
char	**argv;
{
	char	*ptr,*str,pathI[PATH_LEN],pathO[PATH_LEN];
	double	baseO,stepO,baseI,stepI;
	int	BPS;

	if (argc!=4 && argc!=6 && argc!=8) {
	    for (ptr=str=argv[0]; *ptr!='\0'; ptr++) if (*ptr=='/') str=ptr+1;

	    fprintf(stderr,"usage : %s pI BI sI pO bO sO BPS\n"
			   "usage : %s bI sI bO sO BPS\n"
			   "usage : %s bO sO BPS\n",str,str,str); exit(1);
	}
	baseO=atof(argv[argc-3]);

	if ((stepO=atof(argv[argc-2]))<=0.0) {
	    fputs("bad step value.\n",stderr); exit(1);
	}
	if ((BPS=atoi(argv[argc-1]))<=0 || BPS>8*sizeof(Cell)) {
	    fputs("bad BPS (Bits Per Sample).\n",stderr); exit(1);
	}
	if (argc==8)
	    ConvertValue(argv[1],atof(argv[2]),atof(argv[3]),
			 argv[4],baseO,stepO,BPS);
	else if (argc==6) {
	    baseI=atof(argv[1]);
	    stepI=atof(argv[2]);

	    while (scanf("%s %s",pathI,pathO)==2)
		ConvertValue(pathI,baseI,stepI,pathO,baseO,stepO,BPS);
	}
	else 
	    while (scanf("%s %lf %lf %s",pathI,&baseI,&stepI,pathO)==4)
		ConvertValue(pathI,baseI,stepI,pathO,baseO,stepO,BPS);

	return 0;
}
